/*****************************************************************/
/*
/* space_intern.c copyright (c) 1994 Clemson University, all rights reserved.
/*
/* SPACE_INTERN.C - 
/*
/*
/* $Log: space_intern.c,v $
 * Revision 1.1  1995/02/28  17:12:54  rheil
 * Initial revision
 *
/*  1/1/1994  - Code Origination, Robert M. Heil (Bob)
/*  1/10/1995 - Support SPARC as well as ALPHA, can run multiple processors.
/*
/******************************************************************/
/* UNIX INCLUDE FILES */
#include <stdio.h>
 
/* CREATE_1B INCLUDE FILES */
#include "macros.h"
#include "types.h"
#include "hrpt.h"

/* GLOBAL VARIABLES */
static char space_intern_c[] = "$Header: /projects/level1b/create.1bl/C/RCS/space_intern.c,v 1.1 1995/02/28 17:12:54 rheil Exp $";
/******************************************************************/

void space_intern(scanline,rundata,stack,t,s)
hrpt_scanline *scanline;
runrec        *rundata;
int4          stack;
flt4          t[3],s[3];
{
    int4  i, k1, k2, channel;
    flt4 sum1, sum2, delval1, delval2;
   
    for (i=0;i<10;i++)
        for (channel=0;channel<3;channel++)
        {
           rundata->xtarget[channel][i] = scanline->doc.internal[i].ch[channel];
           rundata->xspace[channel][i]  = scanline->doc.space[i].ch[channel+2];
        }
    for (channel=0;channel<3;channel++)
    {
        sum1 = sum2 = 0;
        for (i=0;i<10;i++)
        {
             sum1 += rundata->xtarget[channel][i];
             sum2 += rundata->xspace[channel][i];
        }
        t[channel] = sum1/(10);
        s[channel] = sum2/(10);
    }
    for (channel=0;channel<3;channel++)
    {
        sum1 = sum2 = k1 = k2 = 0;
        for (i=0;i<(10);i++)
        {
            delval1 = t[channel] - rundata->xtarget[channel][i];
            if (delval1 < 0) delval1 *= -1;
            delval2 = s[channel] - rundata->xspace[channel][i];
            if (delval2 < 0) delval2 *= -1;
            if (delval1 <= 100)
            {
                k1 += 1;
                sum1 += rundata->xtarget[channel][i];
            }
            if (delval2 <= 100)
            {
                k2 += 1;
                sum2 += rundata->xspace[channel][i];
            }
        }
        if (k1 >= 1)
            t[channel] = sum1/k1;
        if (k2 >= 1)
            s[channel] = sum2/k2;
    }
}
